#include <SPI.h>
#include"RFID.h"

// Pins
const int chipSelectPin = 10;
const int NRSTPD = 5;
const int scalePin = A0;
const int btn1Pin = 2;
const int btn2Pin = 3;
const int btn3Pin = 4;
const int sol1Pin = 6;
const int sol2Pin = 7;
const int sol3Pin = 8;

int pressedButton = 0;
int sample = 120;
int stp = 0;
unsigned long int sum = 0;
int recivedByte;
RFID rfid(chipSelectPin, NRSTPD);

void Close() {
    digitalWrite(sol1Pin, LOW);
    digitalWrite(sol2Pin, LOW);
    digitalWrite(sol3Pin, LOW);
}

void setup() {
	Serial.begin(9600);
	SPI.begin();
	pinMode(scalePin, INPUT);
    pinMode(btn1Pin, INPUT);
    pinMode(btn2Pin, INPUT);
    pinMode(btn3Pin, INPUT);
    pinMode(sol1Pin, OUTPUT);
    pinMode(sol2Pin, OUTPUT);
    pinMode(sol3Pin, OUTPUT);
   	rfid.init();
}

void Button() {
    if (digitalRead(btn1Pin) == HIGH) pressedButton = 1;
    else if (digitalRead(btn2Pin) == HIGH) pressedButton = 2;
    else if (digitalRead(btn3Pin) == HIGH) pressedButton = 3;
}

int Scale() {
    stp++;
    sum += analogRead(scalePin);
    if (stp > sample) {
        int weight = sum / sample;
        sum = 0;
        stp = 0;
        return weight;
    } else return -1;
}

void Open() {
  if (pressedButton == 1) digitalWrite(sol1Pin, HIGH);
  else if (pressedButton == 2) digitalWrite(sol2Pin, HIGH);
  else if (pressedButton == 3) digitalWrite(sol3Pin, HIGH);
  Close();
}

void loop() {
    int weight = Scale();
    if (weight != -1) {
        if (rfid.isCard()) {
        	if (rfid.readCardSerial()) {
                Button();
        		Serial.print(weight);
        		Serial.print("; ");
        		Serial.print(rfid.serNum[0]);
        		Serial.print(rfid.serNum[1]);
        		Serial.print(rfid.serNum[2]);
        		Serial.print(rfid.serNum[3]);
                Serial.print("; ");
                Serial.println(pressedButton);
                while (Serial.available() > 0) {
        			recivedByte = Serial.read();
        			if (recivedByte != 0) {
        		          pressedButton = 0;
        			}
        		}
        	}
        } else {
        	pressedButton = 0;
        }
        Open();
        rfid.halt();
    }
}